<?php

session_start();

include_once "include/global_variables.php";
include_once "include/functions.php";
verify_user();

$path = '';
if (isset($_GET['path'])){
  $path = $_GET['path'];
  $path = preg_replace("/^\//", '', $path);
}

$update_parent_acls = false;
$update_parent_adr  = false;
$recursion = false;
$active_tab = 0;

if( isset( $_POST['recursive_acls'] ) && $_POST['recursive_acls'] == 'true' ){
  $recursion = true;
}

if ( ( isset( $_POST['users_acls'] ) || isset( $_POST['groups_acls'] ) ) && isset($_POST['file_path']) ){
  if ( $recursion == true ){
    recursively_replace_acls( $_POST );
  } else {
    replace_acls( $_POST );
  }
  $update_parent_acls = true;
  $active_tab = 0;
}


if ( isset( $_POST['adr'] ) && isset($_POST['file_path']) ){
   // print_r($_POST['adr']);

  save_incoming_adresses($_POST['adr'],$_POST['file_path']);
  $update_parent_adr = true;
  $active_tab = 1;
}



$span_id_to_update = id_from_path(format_path($path));
$available_perms = unserialize(PERMS_GUI);
$perms_imap = unserialize(PERMS_GUI_TO_IMAP);
$perms_imap = array_flip($perms_imap);
$permissions = get_folder_perms( $path );
$available_domains = unserialize(AVAILABLE_DOMAINS);
$folder_name = format_folder_name($path);


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Control window</title>
    <meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
    <link rel="icon" type="image/png" href="favicon.png" />
    <script type="text/javascript" src="js/jquery-1.10.2.min.js"></script>
    <script type="text/javascript" src="js/jquery.blockUI.js"></script>
    <script src="http://code.jquery.com/ui/1.10.3/jquery-ui.js"></script>
    <link href="styles/style.css" rel="stylesheet" type="text/css" media="screen" />
    <link rel="stylesheet" href="styles/table.css" type="text/css" />
    <script>
    $(function() {
      $( "#tabs" ).tabs({ active: <?php print $active_tab ?> });
    });
    </script>
  </head>
  <body>
  <table>
  <tr>
    <th align="center" style="text-align:center">Folder : <?php print $path ?></th>
  </tr>
  </table>
  <div id="tabs" >
    <div id="tabs-container">
      <ul>
        <li><a href="#tab-1">ACLs</a></li>
        <li><a href="#tab-2">Mail adresses</a></li>
      </ul>
    </div>

    <div id="tab-1">
<?php

########################################################################################
#                                                                                      #
#                                       USERS                                          #
#                                                                                      #
########################################################################################

?>
<!-- <h3># Access Control List :</h3> -->
  <form method="post" id="acls" name="acls" action="">
  <input type='hidden' name='file_path' value='<?php print $path; ?>'/></td>

  <table id='users_acls' name='users_acls'>
  <tr>
    <th>User</th><th>Permission</th><th> </th>
  </tr>

<?php

print "<tr>
  <td>All</td>\n";
print "  <td>
    <select name='users_acls[0][permission]' id='auth_name_0' >";
foreach ($available_perms as $key => $value) {
  $s = '';
  if( $key == $perms_imap[$permissions['anyone']['anyone']] ){
    $s =  ' selected="selected" ';
  }
  print "\n      ".'<option value="'.$key.'"'.$s.'>'.$value.'</option>';
}
print "\n    </select>";
print "<input type='hidden' name='users_acls[0][auth_name]' value='anyone'/>\n";
print "<input type='hidden' name='users_acls[0][auth_type]' value='anyone'/>\n";
print "
  </td>
  <td>
    -
  </td>
</tr>";
$i = 1;
if ( isset( $permissions['user'] ) ){
  foreach ($permissions['user'] as $key => $value) {
    print "<tr><td>".$key."</td>";
    
    print "<td><select name='users_acls[$i][permission]' >";
    foreach ($available_perms as $k => $v) {
      $s = '';
      print_r($perms_imap);
      if ( $k == $perms_imap[$value] ){
        $s = '  selected="selected" ';
      }
      print '<option '.$s.' value="'.$k.'">'.$v.'</option>';
    }
    print "</select>";
    print "<input type='hidden' name='users_acls[$i][auth_name]' id='user_auth_name_".$i."' value='".$key."'/>\n";
    print "<input type='hidden' name='users_acls[$i][auth_type]' value='user'/></td><td>
    <img alt='Del.' src='styles/images/del.png' width='25px' height='25px' onclick='remove_row(this,\"users_acls\")'/>
  </td>
\n";
    $i++;
  }
}
?>
      <tr>
        <td colspan="3" >
          <a href="#" onclick="add_Row('users_acls')" id="edit_href"> + Add new</a></td>
      </tr>
    </table>
<?php

########################################################################################
#                                                                                      #
#                                       GROUPS                                         #
#                                                                                      #
########################################################################################

?>
  <table id='groups_acls' name='groups_acls'>
  <tr>
    <th>Group</th><th>Permission</th><th> </th>
  </tr>

<?php

$i = 1;
if ( isset( $permissions['group'] ) ){
  foreach ($permissions['group'] as $key => $value) {
    print "<tr><td>".$key."</td>";
    
    print "<td><select name='groups_acls[$i][permission]' >";
    foreach ($available_perms as $k => $v) {
      $s = '';
      if ( $k == $perms_imap[$value] ){
        $s = '  selected="selected" ';
      }
      print '<option '.$s.' value="'.$k.'">'.$v.'</option>';
    }
    print "</select>";
    print "<input type='hidden' name='groups_acls[$i][auth_name]' id='group_auth_name_".$i."' value='".$key."'/>\n";
    print "<input type='hidden' name='groups_acls[$i][auth_type]' value='group'/></td><td>
    <img alt='Del.' src='styles/images/del.png' width='25px' height='25px' onclick='remove_row(this,\"groups_acls\")'/>
  </td>
\n";
    $i++;
  }
}
?>
      <tr>
        <td colspan="3" >
          <a href="#" onclick="add_Row('groups_acls')" id="edit_href"> + Add new</a></td>
      </tr>
    </table>

<?php

########################################################################################
#                                                                                      #
#                                         END                                          #
#                                                                                      #
########################################################################################

?>

    <table>
      <tr>
        <td>
          <input type="checkbox" name="recursive_acls" value="true"> recursive
          <button style="float: right;" onclick="formSubmit('acls');">Apply ACLs</button>
        </td>
      </tr>
    </table>
    </form>

  </div>
  <div id="tab-2">
    <form method="post" id="addresses" name="addresses" action="">
    <input type='hidden' name='file_path' value='<?php print $path; ?>'/></td>

  <?php

    $incoming_addresses = directory_incoming_addresses($path);
    #print_r($incoming_addresses);

  ?>
    <!-- <h3># Mailbox Addresses :</h3> -->
    <table id='mail_adresses' name='mail_adresses'>
    <tr>
      <th>Name</th><th style="width:0px">  </th><th>Domain</th><th></th>
    </tr>
    <?php
      if( count($incoming_addresses) > 0 ){
        $i = 0;
        foreach ($incoming_addresses as $key => $value) {
          $name = preg_replace('/\@.*$/','',$value['address']);
          $domain = preg_replace('/^[^\@]+@/','',$value['address']);
          print "<tr>";
          print "

          <td style='text-align:right;'>$name<input type='hidden' name='adr[$i][name]' value=\"".$name."\"/>
          </td>
          <td style=\"width:0px\" >&nbsp;@&nbsp;</td>
          <td align=\"left\">$domain<input type='hidden' name='adr[$i][domain]' value='".$domain."'/>
          </td>
          <td>
            <img alt='Del.' src='styles/images/del.png' width='25px' height='25px' onclick='remove_row(this,\"mail_adresses\")'/>
          </td>";
          print "</tr>";
          $i++;
        }
      }
    ?>
      <tr>
        <td colspan="4" >
          <a href="#" onclick="add_Row_addr('mail_adresses')" id="edit_href"> + Add new</a>
        </td>
      </tr>
    </table>
  </form>
  <table>
    <tr>
      <td>
        <button style="float: right;" onclick="formSubmit('addresses');">Define addresses</button>
      </td>
    </tr>
  </table>
  </div>
</div>



    <script type="text/javascript">
    function add_Row(table) {
      type = '';
      if ( table == 'users_acls' ){
        type = 'user';
      } else if ( table == 'groups_acls' ) {
        type = 'group';
      }
      var table = document.getElementById(table);
      var rowCount = table.rows.length;
      list = '';
      list_lenght = 1;
      for (var i = 1; i < rowCount; i++) {
        var name = '';
        if ( document.getElementById(type+"_auth_name_"+i) ){
          var input = document.getElementById(type+"_auth_name_"+i);
          if ( input.tagName.toLowerCase() == "select" ){
            name = input.options[input.selectedIndex].value;
          } else {
            name = input.value;
          }
        }
        if ( name != '' ){ 
          list = list+name+",";
          list_lenght = list_lenght + 1;
        }
      }
      present = '';
      if ( list_lenght > 0 ){
        present = '?present='+list;
      }
      url = "include/get_select_"+type+"_list.php"+present;
      var select_list = get_html_content(url);
      if ( select_list != ''){
        var row = table.insertRow(rowCount-1);
        var cell1 = row.insertCell(0);
        var select = '<select name="'+type+'s_acls['+list_lenght+'][auth_name]" id="'+type+'_auth_name_'+list_lenght+'">'+select_list+'</select>';
        cell1.innerHTML = select;
        var permissions = "<?php
    $i = $i+1;
    print '<select name=\""+type+"s_acls["+list_lenght+"][permission]\">';
    foreach ($available_perms as $key => $value) {
      print '<option value=\"'.$key.'\">'.$value.'</option>';
    }
    print '</select>';
    ?>"+"<input type='hidden' name=\""+type+"s_acls["+list_lenght+"][auth_type]\" value='"+type+"'/>";
        var cell2 = row.insertCell(1);
        cell2.innerHTML = permissions;
        var dell_cell = "<img alt='Del.' src='styles/images/del.png' width='25px' height='25px' onclick='remove_row(this,\""+type+"s_acls\")'/>";
        var cell3 = row.insertCell(2);
        cell3.innerHTML = dell_cell;
      } else {
        alert("There are no more "+type+"s to add to this table.");
      }
    }

    function add_Row_addr(table) {
      var table = document.getElementById(table);
      var rowCount = table.rows.length;
      list = '';
      list_lenght = 1;
      url = "include/get_select_domains.php";
      var suggested_name = get_html_content(url);
      var row = table.insertRow(rowCount-1);
      var cell1 = row.insertCell(0);
      var local_part = '<input type="text" name="adr['+(rowCount - 2)+'][name]" style="text-align:right; width:100%" value="<?php print $folder_name ?>"/>';
      cell1.innerHTML = local_part;
      var cell2 = row.insertCell(1);
      cell2.style.width = '0px';
      cell2.innerHTML = '&nbsp;@&nbsp;';
      var cell3 = row.insertCell(2);
      cell3.innerHTML = '<select name="adr['+(rowCount - 2)+'][domain]" ><?php
      foreach( $available_domains as $dom ){
        print "<option value=\"$dom\">$dom</option>";
      }
      ?></select>';
      var dell_cell = "<img alt='Del.' src='styles/images/del.png' width='25px' height='25px' onclick='remove_row(this,\"mail_adresses\")'/>";
      var cell4 = row.insertCell(3);
      cell4.innerHTML = dell_cell;
    }

    function remove_row(r,table_id){
      var row= r.parentNode.parentNode;
      var table = document.getElementById(table_id);
      table.deleteRow(row.rowIndex);
    }

    function get_html_content( url ) {
         var result = null;
         var scriptUrl = url;
         $.ajax({
            url: scriptUrl,
            type: 'get',
            dataType: 'html',
            async: false,
            success: function(data) {
                result = data;
            } 
         });
         return result;
    }

    function formSubmit(form){
      $.blockUI({ message: "Applying. Please wait ..." });
      setTimeout($.unblockUI, 100000); 
      document.getElementById(form).submit();
    }

    <?php 
      if ($update_parent_acls == true){
    ?>
      window.opener.load_acls_list_to_span(﻿"<?php echo 'span_acls_'.$span_id_to_update ?>",﻿"<?php echo $path ?>",﻿"<?php echo json_encode($recursion); ?>");
    <?php 
      }
    ?>

    <?php 
      if ($update_parent_adr == true){
    ?>
﻿      window.opener.load_mail_list_to_span(﻿"<?php echo 'span_mail_'.$span_id_to_update ?>",﻿"<?php echo $path ?>"); 
    <?php 
      }
    ?>

    window.focus()

  </script>


</body>
</html>
